# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_cipher`](#dsc_cipher): The DSC Cipher resource type. Automatically generated from version 1.1.0.0
* [`dsc_ciphersuites`](#dsc_ciphersuites): The DSC CipherSuites resource type. Automatically generated from version 1.1.0.0
* [`dsc_hash`](#dsc_hash): The DSC Hash resource type. Automatically generated from version 1.1.0.0
* [`dsc_keyexchangealgorithm`](#dsc_keyexchangealgorithm): The DSC KeyExchangeAlgorithm resource type. Automatically generated from version 1.1.0.0
* [`dsc_protocol`](#dsc_protocol): The DSC Protocol resource type. Automatically generated from version 1.1.0.0
* [`dsc_schannelsettings`](#dsc_schannelsettings): The DSC SChannelSettings resource type. Automatically generated from version 1.1.0.0

## Resource types

### `dsc_cipher`

The DSC Cipher resource type.
Automatically generated from version 1.1.0.0

#### Properties

The following properties are available in the `dsc_cipher` type.

##### `dsc_state`

Data type: `Optional[Enum['Enabled', 'Disabled', 'Default']]`

 

#### Parameters

The following parameters are available in the `dsc_cipher` type.

##### `dsc_cipher`

namevar

Data type: `Enum['AES 128/128', 'AES 256/256', 'DES 56/56', 'NULL', 'RC2 128/128', 'RC2 40/128', 'RC2 56/128', 'RC4 128/128', 'RC4 40/128', 'RC4 56/128', 'RC4 64/128', 'Triple DES 168']`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_ciphersuites`

The DSC CipherSuites resource type.
Automatically generated from version 1.1.0.0

#### Properties

The following properties are available in the `dsc_ciphersuites` type.

##### `dsc_ciphersuitesorder`

Data type: `Optional[Array[String]]`

 

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

 

#### Parameters

The following parameters are available in the `dsc_ciphersuites` type.

##### `dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_hash`

The DSC Hash resource type.
Automatically generated from version 1.1.0.0

#### Properties

The following properties are available in the `dsc_hash` type.

##### `dsc_state`

Data type: `Optional[Enum['Enabled', 'Disabled', 'Default']]`

 

#### Parameters

The following parameters are available in the `dsc_hash` type.

##### `dsc_hash`

namevar

Data type: `Enum['MD5', 'SHA', 'SHA256', 'SHA384', 'SHA512']`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_keyexchangealgorithm`

The DSC KeyExchangeAlgorithm resource type.
Automatically generated from version 1.1.0.0

#### Properties

The following properties are available in the `dsc_keyexchangealgorithm` type.

##### `dsc_state`

Data type: `Optional[Enum['Enabled', 'Disabled', 'Default']]`

 

#### Parameters

The following parameters are available in the `dsc_keyexchangealgorithm` type.

##### `dsc_keyexchangealgorithm`

namevar

Data type: `Enum['Diffie-Hellman', 'ECDH', 'PKCS']`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_protocol`

The DSC Protocol resource type.
Automatically generated from version 1.1.0.0

#### Properties

The following properties are available in the `dsc_protocol` type.

##### `dsc_includeclientside`

Data type: `Optional[Boolean]`

 

##### `dsc_state`

Data type: `Optional[Enum['Enabled', 'Disabled', 'Default']]`

 

#### Parameters

The following parameters are available in the `dsc_protocol` type.

##### `dsc_protocol`

namevar

Data type: `Enum['Multi-Protocol Unified Hello', 'PCT 1.0', 'SSL 2.0', 'SSL 3.0', 'TLS 1.0', 'TLS 1.1', 'TLS 1.2']`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_schannelsettings`

The DSC SChannelSettings resource type.
Automatically generated from version 1.1.0.0

#### Properties

The following properties are available in the `dsc_schannelsettings` type.

##### `dsc_diffiehellmanminclientkeysize`

Data type: `Optional[Enum['1024', '2048', '3072', '4096']]`

Minimum client key size for the Diffie-Hellman key exchange algorithm

##### `dsc_diffiehellmanminserverkeysize`

Data type: `Optional[Enum['1024', '2048', '3072', '4096']]`

Minimum server key size for the Diffie-Hellman key exchange algorithm

##### `dsc_enablefipsalgorithmpolicy`

Data type: `Optional[Boolean]`

Specifies if the FIPS Algorithm Policy is enabled

##### `dsc_tls12state`

Data type: `Optional[Enum['Enabled', 'Disabled', 'Default']]`

Specifies the state of TLS 1.2 for the .Net Framework 3.5 and 4.0 (not required for v4.6 and above)

#### Parameters

The following parameters are available in the `dsc_schannelsettings` type.

##### `dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

